# coding: utf-8

"""
    Marlowe Runtime REST API

    REST API for Marlowe Runtime

    The version of the OpenAPI document: 0.0.5.1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
from inspect import getfullargspec
import json
import pprint
import re  # noqa: F401

from typing import Any, List, Optional
from pydantic import BaseModel, Field, StrictStr, ValidationError, validator
from openapi_client.models.choice_action_object import ChoiceActionObject
from openapi_client.models.deposit_action_object import DepositActionObject
from openapi_client.models.label_ref import LabelRef
from openapi_client.models.notify_action_object import NotifyActionObject
from typing import Union, Any, List, TYPE_CHECKING
from pydantic import StrictStr, Field

ACTIONOBJECT_ONE_OF_SCHEMAS = ["ChoiceActionObject", "DepositActionObject", "LabelRef", "NotifyActionObject"]

class ActionObject(BaseModel):
    """
    A contract which becomes active when an action occurs.
    """
    # data type: DepositActionObject
    oneof_schema_1_validator: Optional[DepositActionObject] = None
    # data type: ChoiceActionObject
    oneof_schema_2_validator: Optional[ChoiceActionObject] = None
    # data type: NotifyActionObject
    oneof_schema_3_validator: Optional[NotifyActionObject] = None
    # data type: LabelRef
    oneof_schema_4_validator: Optional[LabelRef] = None
    if TYPE_CHECKING:
        actual_instance: Union[ChoiceActionObject, DepositActionObject, LabelRef, NotifyActionObject]
    else:
        actual_instance: Any
    one_of_schemas: List[str] = Field(ACTIONOBJECT_ONE_OF_SCHEMAS, const=True)

    class Config:
        validate_assignment = True

    def __init__(self, *args, **kwargs) -> None:
        if args:
            if len(args) > 1:
                raise ValueError("If a position argument is used, only 1 is allowed to set `actual_instance`")
            if kwargs:
                raise ValueError("If a position argument is used, keyword arguments cannot be used.")
            super().__init__(actual_instance=args[0])
        else:
            super().__init__(**kwargs)

    @validator('actual_instance')
    def actual_instance_must_validate_oneof(cls, v):
        instance = ActionObject.construct()
        error_messages = []
        match = 0
        # validate data type: DepositActionObject
        if not isinstance(v, DepositActionObject):
            error_messages.append(f"Error! Input type `{type(v)}` is not `DepositActionObject`")
        else:
            match += 1
        # validate data type: ChoiceActionObject
        if not isinstance(v, ChoiceActionObject):
            error_messages.append(f"Error! Input type `{type(v)}` is not `ChoiceActionObject`")
        else:
            match += 1
        # validate data type: NotifyActionObject
        if not isinstance(v, NotifyActionObject):
            error_messages.append(f"Error! Input type `{type(v)}` is not `NotifyActionObject`")
        else:
            match += 1
        # validate data type: LabelRef
        if not isinstance(v, LabelRef):
            error_messages.append(f"Error! Input type `{type(v)}` is not `LabelRef`")
        else:
            match += 1
        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when setting `actual_instance` in ActionObject with oneOf schemas: ChoiceActionObject, DepositActionObject, LabelRef, NotifyActionObject. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when setting `actual_instance` in ActionObject with oneOf schemas: ChoiceActionObject, DepositActionObject, LabelRef, NotifyActionObject. Details: " + ", ".join(error_messages))
        else:
            return v

    @classmethod
    def from_dict(cls, obj: dict) -> ActionObject:
        return cls.from_json(json.dumps(obj))

    @classmethod
    def from_json(cls, json_str: str) -> ActionObject:
        """Returns the object represented by the json string"""
        instance = ActionObject.construct()
        error_messages = []
        match = 0

        # deserialize data into DepositActionObject
        try:
            instance.actual_instance = DepositActionObject.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into ChoiceActionObject
        try:
            instance.actual_instance = ChoiceActionObject.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into NotifyActionObject
        try:
            instance.actual_instance = NotifyActionObject.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into LabelRef
        try:
            instance.actual_instance = LabelRef.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))

        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when deserializing the JSON string into ActionObject with oneOf schemas: ChoiceActionObject, DepositActionObject, LabelRef, NotifyActionObject. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when deserializing the JSON string into ActionObject with oneOf schemas: ChoiceActionObject, DepositActionObject, LabelRef, NotifyActionObject. Details: " + ", ".join(error_messages))
        else:
            return instance

    def to_json(self) -> str:
        """Returns the JSON representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        to_json = getattr(self.actual_instance, "to_json", None)
        if callable(to_json):
            return self.actual_instance.to_json()
        else:
            return json.dumps(self.actual_instance)

    def to_dict(self) -> dict:
        """Returns the dict representation of the actual instance"""
        if self.actual_instance is None:
            return None

        to_dict = getattr(self.actual_instance, "to_dict", None)
        if callable(to_dict):
            return self.actual_instance.to_dict()
        else:
            # primitive type
            return self.actual_instance

    def to_str(self) -> str:
        """Returns the string representation of the actual instance"""
        return pprint.pformat(self.dict())


