# coding: utf-8

"""
    Marlowe Runtime REST API

    REST API for Marlowe Runtime

    The version of the OpenAPI document: 0.0.5.1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json



from pydantic import BaseModel, Field, StrictStr, constr, validator

class AssetId(BaseModel):
    """
    AssetId
    """
    asset_name: StrictStr = Field(..., alias="assetName")
    policy_id: constr(strict=True) = Field(..., alias="policyId", description="The hex-encoded minting policy ID for a native Cardano token")
    __properties = ["assetName", "policyId"]

    @validator('policy_id')
    def policy_id_validate_regular_expression(cls, value):
        """Validates the regular expression"""
        if not re.match(r"^[a-fA-F0-9]*$", value):
            raise ValueError(r"must validate the regular expression /^[a-fA-F0-9]*$/")
        return value

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> AssetId:
        """Create an instance of AssetId from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> AssetId:
        """Create an instance of AssetId from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return AssetId.parse_obj(obj)

        _obj = AssetId.parse_obj({
            "asset_name": obj.get("assetName"),
            "policy_id": obj.get("policyId")
        })
        return _obj


