# coding: utf-8

"""
    Marlowe Runtime REST API

    REST API for Marlowe Runtime

    The version of the OpenAPI document: 0.0.5.1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
from inspect import getfullargspec
import json
import pprint
import re  # noqa: F401

from typing import Any, List, Optional
from pydantic import BaseModel, Field, StrictStr, ValidationError, validator
from openapi_client.models.close_object import CloseObject
from openapi_client.models.label_ref import LabelRef
from typing import Union, Any, List, TYPE_CHECKING
from pydantic import StrictStr, Field

CONTRACTOBJECT_ONE_OF_SCHEMAS = ["AssertObject", "CloseObject", "IfObject", "LabelRef", "LetObject", "PayObject", "WhenObject"]

class ContractObject(BaseModel):
    """
    Contract terms specified in Marlowe
    """
    # data type: CloseObject
    oneof_schema_1_validator: Optional[CloseObject] = None
    # data type: PayObject
    oneof_schema_2_validator: Optional[PayObject] = None
    # data type: IfObject
    oneof_schema_3_validator: Optional[IfObject] = None
    # data type: WhenObject
    oneof_schema_4_validator: Optional[WhenObject] = None
    # data type: LetObject
    oneof_schema_5_validator: Optional[LetObject] = None
    # data type: AssertObject
    oneof_schema_6_validator: Optional[AssertObject] = None
    # data type: LabelRef
    oneof_schema_7_validator: Optional[LabelRef] = None
    if TYPE_CHECKING:
        actual_instance: Union[AssertObject, CloseObject, IfObject, LabelRef, LetObject, PayObject, WhenObject]
    else:
        actual_instance: Any
    one_of_schemas: List[str] = Field(CONTRACTOBJECT_ONE_OF_SCHEMAS, const=True)

    class Config:
        validate_assignment = True

    def __init__(self, *args, **kwargs) -> None:
        if args:
            if len(args) > 1:
                raise ValueError("If a position argument is used, only 1 is allowed to set `actual_instance`")
            if kwargs:
                raise ValueError("If a position argument is used, keyword arguments cannot be used.")
            super().__init__(actual_instance=args[0])
        else:
            super().__init__(**kwargs)

    @validator('actual_instance')
    def actual_instance_must_validate_oneof(cls, v):
        instance = ContractObject.construct()
        error_messages = []
        match = 0
        # validate data type: CloseObject
        if not isinstance(v, CloseObject):
            error_messages.append(f"Error! Input type `{type(v)}` is not `CloseObject`")
        else:
            match += 1
        # validate data type: PayObject
        if not isinstance(v, PayObject):
            error_messages.append(f"Error! Input type `{type(v)}` is not `PayObject`")
        else:
            match += 1
        # validate data type: IfObject
        if not isinstance(v, IfObject):
            error_messages.append(f"Error! Input type `{type(v)}` is not `IfObject`")
        else:
            match += 1
        # validate data type: WhenObject
        if not isinstance(v, WhenObject):
            error_messages.append(f"Error! Input type `{type(v)}` is not `WhenObject`")
        else:
            match += 1
        # validate data type: LetObject
        if not isinstance(v, LetObject):
            error_messages.append(f"Error! Input type `{type(v)}` is not `LetObject`")
        else:
            match += 1
        # validate data type: AssertObject
        if not isinstance(v, AssertObject):
            error_messages.append(f"Error! Input type `{type(v)}` is not `AssertObject`")
        else:
            match += 1
        # validate data type: LabelRef
        if not isinstance(v, LabelRef):
            error_messages.append(f"Error! Input type `{type(v)}` is not `LabelRef`")
        else:
            match += 1
        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when setting `actual_instance` in ContractObject with oneOf schemas: AssertObject, CloseObject, IfObject, LabelRef, LetObject, PayObject, WhenObject. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when setting `actual_instance` in ContractObject with oneOf schemas: AssertObject, CloseObject, IfObject, LabelRef, LetObject, PayObject, WhenObject. Details: " + ", ".join(error_messages))
        else:
            return v

    @classmethod
    def from_dict(cls, obj: dict) -> ContractObject:
        return cls.from_json(json.dumps(obj))

    @classmethod
    def from_json(cls, json_str: str) -> ContractObject:
        """Returns the object represented by the json string"""
        instance = ContractObject.construct()
        error_messages = []
        match = 0

        # deserialize data into CloseObject
        try:
            instance.actual_instance = CloseObject.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into PayObject
        try:
            instance.actual_instance = PayObject.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into IfObject
        try:
            instance.actual_instance = IfObject.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into WhenObject
        try:
            instance.actual_instance = WhenObject.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into LetObject
        try:
            instance.actual_instance = LetObject.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into AssertObject
        try:
            instance.actual_instance = AssertObject.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into LabelRef
        try:
            instance.actual_instance = LabelRef.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))

        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when deserializing the JSON string into ContractObject with oneOf schemas: AssertObject, CloseObject, IfObject, LabelRef, LetObject, PayObject, WhenObject. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when deserializing the JSON string into ContractObject with oneOf schemas: AssertObject, CloseObject, IfObject, LabelRef, LetObject, PayObject, WhenObject. Details: " + ", ".join(error_messages))
        else:
            return instance

    def to_json(self) -> str:
        """Returns the JSON representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        to_json = getattr(self.actual_instance, "to_json", None)
        if callable(to_json):
            return self.actual_instance.to_json()
        else:
            return json.dumps(self.actual_instance)

    def to_dict(self) -> dict:
        """Returns the dict representation of the actual instance"""
        if self.actual_instance is None:
            return None

        to_dict = getattr(self.actual_instance, "to_dict", None)
        if callable(to_dict):
            return self.actual_instance.to_dict()
        else:
            # primitive type
            return self.actual_instance

    def to_str(self) -> str:
        """Returns the string representation of the actual instance"""
        return pprint.pformat(self.dict())

from openapi_client.models.assert_object import AssertObject
from openapi_client.models.if_object import IfObject
from openapi_client.models.let_object import LetObject
from openapi_client.models.pay_object import PayObject
from openapi_client.models.when_object import WhenObject
ContractObject.update_forward_refs()

