# coding: utf-8

"""
    Marlowe Runtime REST API

    REST API for Marlowe Runtime

    The version of the OpenAPI document: 0.0.5.1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json



from pydantic import BaseModel, Field, StrictStr, validator
from openapi_client.models.labelled_object_value import LabelledObjectValue

class LabelledObject(BaseModel):
    """
    A bundle of labelled Marlowe objects in define-before-use order.  # noqa: E501
    """
    label: StrictStr = Field(..., description="An arbitrary text identifier for an object in a Marlowe object bundle.")
    type: StrictStr = Field(...)
    value: LabelledObjectValue = Field(...)
    __properties = ["label", "type", "value"]

    @validator('type')
    def type_validate_enum(cls, value):
        """Validates the enum"""
        if value not in ('value', 'observation', 'contract', 'party', 'token', 'action'):
            raise ValueError("must be one of enum values ('value', 'observation', 'contract', 'party', 'token', 'action')")
        return value

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> LabelledObject:
        """Create an instance of LabelledObject from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of value
        if self.value:
            _dict['value'] = self.value.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> LabelledObject:
        """Create an instance of LabelledObject from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return LabelledObject.parse_obj(obj)

        _obj = LabelledObject.parse_obj({
            "label": obj.get("label"),
            "type": obj.get("type"),
            "value": LabelledObjectValue.from_dict(obj.get("value")) if obj.get("value") is not None else None
        })
        return _obj


