# coding: utf-8

"""
    Marlowe Runtime REST API

    REST API for Marlowe Runtime

    The version of the OpenAPI document: 0.0.5.1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
from inspect import getfullargspec
import json
import pprint
import re  # noqa: F401

from typing import Any, List, Optional
from pydantic import BaseModel, Field, StrictStr, ValidationError, validator
from openapi_client.models.action_object import ActionObject
from openapi_client.models.contract_object import ContractObject
from openapi_client.models.observation_object import ObservationObject
from openapi_client.models.party_object import PartyObject
from openapi_client.models.token_object import TokenObject
from openapi_client.models.value_object import ValueObject
from typing import Union, Any, List, TYPE_CHECKING
from pydantic import StrictStr, Field

LABELLEDOBJECTVALUE_ONE_OF_SCHEMAS = ["ActionObject", "ContractObject", "ObservationObject", "PartyObject", "TokenObject", "ValueObject"]

class LabelledObjectValue(BaseModel):
    """
    LabelledObjectValue
    """
    # data type: ValueObject
    oneof_schema_1_validator: Optional[ValueObject] = None
    # data type: ObservationObject
    oneof_schema_2_validator: Optional[ObservationObject] = None
    # data type: ContractObject
    oneof_schema_3_validator: Optional[ContractObject] = None
    # data type: PartyObject
    oneof_schema_4_validator: Optional[PartyObject] = None
    # data type: TokenObject
    oneof_schema_5_validator: Optional[TokenObject] = None
    # data type: ActionObject
    oneof_schema_6_validator: Optional[ActionObject] = None
    if TYPE_CHECKING:
        actual_instance: Union[ActionObject, ContractObject, ObservationObject, PartyObject, TokenObject, ValueObject]
    else:
        actual_instance: Any
    one_of_schemas: List[str] = Field(LABELLEDOBJECTVALUE_ONE_OF_SCHEMAS, const=True)

    class Config:
        validate_assignment = True

    def __init__(self, *args, **kwargs) -> None:
        if args:
            if len(args) > 1:
                raise ValueError("If a position argument is used, only 1 is allowed to set `actual_instance`")
            if kwargs:
                raise ValueError("If a position argument is used, keyword arguments cannot be used.")
            super().__init__(actual_instance=args[0])
        else:
            super().__init__(**kwargs)

    @validator('actual_instance')
    def actual_instance_must_validate_oneof(cls, v):
        instance = LabelledObjectValue.construct()
        error_messages = []
        match = 0
        # validate data type: ValueObject
        if not isinstance(v, ValueObject):
            error_messages.append(f"Error! Input type `{type(v)}` is not `ValueObject`")
        else:
            match += 1
        # validate data type: ObservationObject
        if not isinstance(v, ObservationObject):
            error_messages.append(f"Error! Input type `{type(v)}` is not `ObservationObject`")
        else:
            match += 1
        # validate data type: ContractObject
        if not isinstance(v, ContractObject):
            error_messages.append(f"Error! Input type `{type(v)}` is not `ContractObject`")
        else:
            match += 1
        # validate data type: PartyObject
        if not isinstance(v, PartyObject):
            error_messages.append(f"Error! Input type `{type(v)}` is not `PartyObject`")
        else:
            match += 1
        # validate data type: TokenObject
        if not isinstance(v, TokenObject):
            error_messages.append(f"Error! Input type `{type(v)}` is not `TokenObject`")
        else:
            match += 1
        # validate data type: ActionObject
        if not isinstance(v, ActionObject):
            error_messages.append(f"Error! Input type `{type(v)}` is not `ActionObject`")
        else:
            match += 1
        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when setting `actual_instance` in LabelledObjectValue with oneOf schemas: ActionObject, ContractObject, ObservationObject, PartyObject, TokenObject, ValueObject. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when setting `actual_instance` in LabelledObjectValue with oneOf schemas: ActionObject, ContractObject, ObservationObject, PartyObject, TokenObject, ValueObject. Details: " + ", ".join(error_messages))
        else:
            return v

    @classmethod
    def from_dict(cls, obj: dict) -> LabelledObjectValue:
        return cls.from_json(json.dumps(obj))

    @classmethod
    def from_json(cls, json_str: str) -> LabelledObjectValue:
        """Returns the object represented by the json string"""
        instance = LabelledObjectValue.construct()
        error_messages = []
        match = 0

        # deserialize data into ValueObject
        try:
            instance.actual_instance = ValueObject.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into ObservationObject
        try:
            instance.actual_instance = ObservationObject.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into ContractObject
        try:
            instance.actual_instance = ContractObject.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into PartyObject
        try:
            instance.actual_instance = PartyObject.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into TokenObject
        try:
            instance.actual_instance = TokenObject.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into ActionObject
        try:
            instance.actual_instance = ActionObject.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))

        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when deserializing the JSON string into LabelledObjectValue with oneOf schemas: ActionObject, ContractObject, ObservationObject, PartyObject, TokenObject, ValueObject. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when deserializing the JSON string into LabelledObjectValue with oneOf schemas: ActionObject, ContractObject, ObservationObject, PartyObject, TokenObject, ValueObject. Details: " + ", ".join(error_messages))
        else:
            return instance

    def to_json(self) -> str:
        """Returns the JSON representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        to_json = getattr(self.actual_instance, "to_json", None)
        if callable(to_json):
            return self.actual_instance.to_json()
        else:
            return json.dumps(self.actual_instance)

    def to_dict(self) -> dict:
        """Returns the dict representation of the actual instance"""
        if self.actual_instance is None:
            return None

        to_dict = getattr(self.actual_instance, "to_dict", None)
        if callable(to_dict):
            return self.actual_instance.to_dict()
        else:
            # primitive type
            return self.actual_instance

    def to_str(self) -> str:
        """Returns the string representation of the actual instance"""
        return pprint.pformat(self.dict())


