# coding: utf-8

"""
    Marlowe Runtime REST API

    REST API for Marlowe Runtime

    The version of the OpenAPI document: 0.0.5.1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json



from pydantic import BaseModel, Field, StrictBool
from openapi_client.models.applicable_inputs import ApplicableInputs

class Next(BaseModel):
    """
    Describe the reducibility (Can be Reduced ?) and the applicability (Can Inputs be Applied ?) for a given contract.  # noqa: E501
    """
    applicable_inputs: ApplicableInputs = Field(...)
    can_reduce: StrictBool = Field(..., description="Indicates if a given contract can be reduced (apply []) or not.")
    __properties = ["applicable_inputs", "can_reduce"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Next:
        """Create an instance of Next from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of applicable_inputs
        if self.applicable_inputs:
            _dict['applicable_inputs'] = self.applicable_inputs.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> Next:
        """Create an instance of Next from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return Next.parse_obj(obj)

        _obj = Next.parse_obj({
            "applicable_inputs": ApplicableInputs.from_dict(obj.get("applicable_inputs")) if obj.get("applicable_inputs") is not None else None,
            "can_reduce": obj.get("can_reduce")
        })
        return _obj


