# coding: utf-8

"""
    Marlowe Runtime REST API

    REST API for Marlowe Runtime

    The version of the OpenAPI document: 0.0.5.1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field
from openapi_client.models.plutus_credential import PlutusCredential
from openapi_client.models.plutus_staking_credential import PlutusStakingCredential

class PlutusAddress(BaseModel):
    """
    A Plutus address.  # noqa: E501
    """
    address_credential: PlutusCredential = Field(..., alias="addressCredential")
    address_staking_credential: Optional[PlutusStakingCredential] = Field(None, alias="addressStakingCredential")
    __properties = ["addressCredential", "addressStakingCredential"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> PlutusAddress:
        """Create an instance of PlutusAddress from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of address_credential
        if self.address_credential:
            _dict['addressCredential'] = self.address_credential.to_dict()
        # override the default output from pydantic by calling `to_dict()` of address_staking_credential
        if self.address_staking_credential:
            _dict['addressStakingCredential'] = self.address_staking_credential.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> PlutusAddress:
        """Create an instance of PlutusAddress from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return PlutusAddress.parse_obj(obj)

        _obj = PlutusAddress.parse_obj({
            "address_credential": PlutusCredential.from_dict(obj.get("addressCredential")) if obj.get("addressCredential") is not None else None,
            "address_staking_credential": PlutusStakingCredential.from_dict(obj.get("addressStakingCredential")) if obj.get("addressStakingCredential") is not None else None
        })
        return _obj


