# coding: utf-8

"""
    Marlowe Runtime REST API

    REST API for Marlowe Runtime

    The version of the OpenAPI document: 0.0.5.1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Dict, List, Optional
from pydantic import BaseModel, Field, StrictStr, conlist
from openapi_client.models.input import Input
from openapi_client.models.marlowe_version import MarloweVersion
from openapi_client.models.metadata import Metadata

class PostTransactionsRequest(BaseModel):
    """
    PostTransactionsRequest
    """
    inputs: conlist(Input) = Field(...)
    invalid_before: Optional[StrictStr] = Field(None, alias="invalidBefore")
    invalid_hereafter: Optional[StrictStr] = Field(None, alias="invalidHereafter")
    metadata: Dict[str, Metadata] = Field(...)
    tags: Dict[str, Metadata] = Field(...)
    version: MarloweVersion = Field(...)
    __properties = ["inputs", "invalidBefore", "invalidHereafter", "metadata", "tags", "version"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> PostTransactionsRequest:
        """Create an instance of PostTransactionsRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in inputs (list)
        _items = []
        if self.inputs:
            for _item in self.inputs:
                if _item:
                    _items.append(_item.to_dict())
            _dict['inputs'] = _items
        # override the default output from pydantic by calling `to_dict()` of each value in metadata (dict)
        _field_dict = {}
        if self.metadata:
            for _key in self.metadata:
                if self.metadata[_key]:
                    _field_dict[_key] = self.metadata[_key].to_dict()
            _dict['metadata'] = _field_dict
        # override the default output from pydantic by calling `to_dict()` of each value in tags (dict)
        _field_dict = {}
        if self.tags:
            for _key in self.tags:
                if self.tags[_key]:
                    _field_dict[_key] = self.tags[_key].to_dict()
            _dict['tags'] = _field_dict
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> PostTransactionsRequest:
        """Create an instance of PostTransactionsRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return PostTransactionsRequest.parse_obj(obj)

        _obj = PostTransactionsRequest.parse_obj({
            "inputs": [Input.from_dict(_item) for _item in obj.get("inputs")] if obj.get("inputs") is not None else None,
            "invalid_before": obj.get("invalidBefore"),
            "invalid_hereafter": obj.get("invalidHereafter"),
            "metadata": dict(
                (_k, Metadata.from_dict(_v))
                for _k, _v in obj.get("metadata").items()
            )
            if obj.get("metadata") is not None
            else None,
            "tags": dict(
                (_k, Metadata.from_dict(_v))
                for _k, _v in obj.get("tags").items()
            )
            if obj.get("tags") is not None
            else None,
            "version": obj.get("version")
        })
        return _obj


