# coding: utf-8

"""
    Marlowe Runtime REST API

    REST API for Marlowe Runtime

    The version of the OpenAPI document: 0.0.5.1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
from inspect import getfullargspec
import json
import pprint
import re  # noqa: F401

from typing import Any, List, Optional
from pydantic import BaseModel, Field, StrictStr, ValidationError, validator
from openapi_client.models.address_and_metadata import AddressAndMetadata
from openapi_client.models.metadata_and_recipients import MetadataAndRecipients
from openapi_client.models.metadata_and_script import MetadataAndScript
from typing import Union, Any, List, TYPE_CHECKING
from pydantic import StrictStr, Field

ROLETOKENCONFIG_ONE_OF_SCHEMAS = ["AddressAndMetadata", "MetadataAndRecipients", "MetadataAndScript", "str"]

class RoleTokenConfig(BaseModel):
    """
    RoleTokenConfig
    """
    # data type: str
    oneof_schema_1_validator: Optional[StrictStr] = Field(None, description="A cardano address, in Bech32 format")
    # data type: AddressAndMetadata
    oneof_schema_2_validator: Optional[AddressAndMetadata] = None
    # data type: MetadataAndScript
    oneof_schema_3_validator: Optional[MetadataAndScript] = None
    # data type: MetadataAndRecipients
    oneof_schema_4_validator: Optional[MetadataAndRecipients] = None
    if TYPE_CHECKING:
        actual_instance: Union[AddressAndMetadata, MetadataAndRecipients, MetadataAndScript, str]
    else:
        actual_instance: Any
    one_of_schemas: List[str] = Field(ROLETOKENCONFIG_ONE_OF_SCHEMAS, const=True)

    class Config:
        validate_assignment = True

    def __init__(self, *args, **kwargs) -> None:
        if args:
            if len(args) > 1:
                raise ValueError("If a position argument is used, only 1 is allowed to set `actual_instance`")
            if kwargs:
                raise ValueError("If a position argument is used, keyword arguments cannot be used.")
            super().__init__(actual_instance=args[0])
        else:
            super().__init__(**kwargs)

    @validator('actual_instance')
    def actual_instance_must_validate_oneof(cls, v):
        instance = RoleTokenConfig.construct()
        error_messages = []
        match = 0
        # validate data type: str
        try:
            instance.oneof_schema_1_validator = v
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # validate data type: AddressAndMetadata
        if not isinstance(v, AddressAndMetadata):
            error_messages.append(f"Error! Input type `{type(v)}` is not `AddressAndMetadata`")
        else:
            match += 1
        # validate data type: MetadataAndScript
        if not isinstance(v, MetadataAndScript):
            error_messages.append(f"Error! Input type `{type(v)}` is not `MetadataAndScript`")
        else:
            match += 1
        # validate data type: MetadataAndRecipients
        if not isinstance(v, MetadataAndRecipients):
            error_messages.append(f"Error! Input type `{type(v)}` is not `MetadataAndRecipients`")
        else:
            match += 1
        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when setting `actual_instance` in RoleTokenConfig with oneOf schemas: AddressAndMetadata, MetadataAndRecipients, MetadataAndScript, str. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when setting `actual_instance` in RoleTokenConfig with oneOf schemas: AddressAndMetadata, MetadataAndRecipients, MetadataAndScript, str. Details: " + ", ".join(error_messages))
        else:
            return v

    @classmethod
    def from_dict(cls, obj: dict) -> RoleTokenConfig:
        return cls.from_json(json.dumps(obj))

    @classmethod
    def from_json(cls, json_str: str) -> RoleTokenConfig:
        """Returns the object represented by the json string"""
        instance = RoleTokenConfig.construct()
        error_messages = []
        match = 0

        # deserialize data into str
        try:
            # validation
            instance.oneof_schema_1_validator = json.loads(json_str)
            # assign value to actual_instance
            instance.actual_instance = instance.oneof_schema_1_validator
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into AddressAndMetadata
        try:
            instance.actual_instance = AddressAndMetadata.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into MetadataAndScript
        try:
            instance.actual_instance = MetadataAndScript.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into MetadataAndRecipients
        try:
            instance.actual_instance = MetadataAndRecipients.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))

        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when deserializing the JSON string into RoleTokenConfig with oneOf schemas: AddressAndMetadata, MetadataAndRecipients, MetadataAndScript, str. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when deserializing the JSON string into RoleTokenConfig with oneOf schemas: AddressAndMetadata, MetadataAndRecipients, MetadataAndScript, str. Details: " + ", ".join(error_messages))
        else:
            return instance

    def to_json(self) -> str:
        """Returns the JSON representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        to_json = getattr(self.actual_instance, "to_json", None)
        if callable(to_json):
            return self.actual_instance.to_json()
        else:
            return json.dumps(self.actual_instance)

    def to_dict(self) -> dict:
        """Returns the dict representation of the actual instance"""
        if self.actual_instance is None:
            return None

        to_dict = getattr(self.actual_instance, "to_dict", None)
        if callable(to_dict):
            return self.actual_instance.to_dict()
        else:
            # primitive type
            return self.actual_instance

    def to_str(self) -> str:
        """Returns the string representation of the actual instance"""
        return pprint.pformat(self.dict())


