# coding: utf-8

"""
    Marlowe Runtime REST API

    REST API for Marlowe Runtime

    The version of the OpenAPI document: 0.0.5.1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List, Optional
from pydantic import BaseModel, Field, StrictStr, conlist
from openapi_client.models.token_metadata_file import TokenMetadataFile

class TokenMetadata(BaseModel):
    """
    Metadata for an NFT, as described by https://cips.cardano.org/cips/cip25/  # noqa: E501
    """
    description: Optional[StrictStr] = None
    files: Optional[conlist(TokenMetadataFile)] = None
    image: StrictStr = Field(...)
    media_type: Optional[StrictStr] = Field(None, alias="mediaType")
    name: StrictStr = Field(...)
    additional_properties: Dict[str, Any] = {}
    __properties = ["description", "files", "image", "mediaType", "name"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> TokenMetadata:
        """Create an instance of TokenMetadata from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                            "additional_properties"
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in files (list)
        _items = []
        if self.files:
            for _item in self.files:
                if _item:
                    _items.append(_item.to_dict())
            _dict['files'] = _items
        # puts key-value pairs in additional_properties in the top level
        if self.additional_properties is not None:
            for _key, _value in self.additional_properties.items():
                _dict[_key] = _value

        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> TokenMetadata:
        """Create an instance of TokenMetadata from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return TokenMetadata.parse_obj(obj)

        _obj = TokenMetadata.parse_obj({
            "description": obj.get("description"),
            "files": [TokenMetadataFile.from_dict(_item) for _item in obj.get("files")] if obj.get("files") is not None else None,
            "image": obj.get("image"),
            "media_type": obj.get("mediaType"),
            "name": obj.get("name")
        })
        # store additional fields in additional_properties
        for _key in obj.keys():
            if _key not in cls.__properties:
                _obj.additional_properties[_key] = obj.get(_key)

        return _obj


