# coding: utf-8

"""
    Marlowe Runtime REST API

    REST API for Marlowe Runtime

    The version of the OpenAPI document: 0.0.5.1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
from inspect import getfullargspec
import json
import pprint
import re  # noqa: F401

from typing import Any, List, Optional
from pydantic import BaseModel, Field, StrictStr, ValidationError, validator
from openapi_client.models.assert_fail import AssertFail
from openapi_client.models.non_positive_deposit import NonPositiveDeposit
from openapi_client.models.non_positive_payment import NonPositivePayment
from openapi_client.models.partial_payment import PartialPayment
from openapi_client.models.variable_shadowing import VariableShadowing
from typing import Union, Any, List, TYPE_CHECKING
from pydantic import StrictStr, Field

TRANSACTIONWARNING_ONE_OF_SCHEMAS = ["AssertFail", "NonPositiveDeposit", "NonPositivePayment", "PartialPayment", "VariableShadowing"]

class TransactionWarning(BaseModel):
    """
    A transaction semantics warning.
    """
    # data type: NonPositiveDeposit
    oneof_schema_1_validator: Optional[NonPositiveDeposit] = None
    # data type: NonPositivePayment
    oneof_schema_2_validator: Optional[NonPositivePayment] = None
    # data type: PartialPayment
    oneof_schema_3_validator: Optional[PartialPayment] = None
    # data type: VariableShadowing
    oneof_schema_4_validator: Optional[VariableShadowing] = None
    # data type: AssertFail
    oneof_schema_5_validator: Optional[AssertFail] = None
    if TYPE_CHECKING:
        actual_instance: Union[AssertFail, NonPositiveDeposit, NonPositivePayment, PartialPayment, VariableShadowing]
    else:
        actual_instance: Any
    one_of_schemas: List[str] = Field(TRANSACTIONWARNING_ONE_OF_SCHEMAS, const=True)

    class Config:
        validate_assignment = True

    def __init__(self, *args, **kwargs) -> None:
        if args:
            if len(args) > 1:
                raise ValueError("If a position argument is used, only 1 is allowed to set `actual_instance`")
            if kwargs:
                raise ValueError("If a position argument is used, keyword arguments cannot be used.")
            super().__init__(actual_instance=args[0])
        else:
            super().__init__(**kwargs)

    @validator('actual_instance')
    def actual_instance_must_validate_oneof(cls, v):
        instance = TransactionWarning.construct()
        error_messages = []
        match = 0
        # validate data type: NonPositiveDeposit
        if not isinstance(v, NonPositiveDeposit):
            error_messages.append(f"Error! Input type `{type(v)}` is not `NonPositiveDeposit`")
        else:
            match += 1
        # validate data type: NonPositivePayment
        if not isinstance(v, NonPositivePayment):
            error_messages.append(f"Error! Input type `{type(v)}` is not `NonPositivePayment`")
        else:
            match += 1
        # validate data type: PartialPayment
        if not isinstance(v, PartialPayment):
            error_messages.append(f"Error! Input type `{type(v)}` is not `PartialPayment`")
        else:
            match += 1
        # validate data type: VariableShadowing
        if not isinstance(v, VariableShadowing):
            error_messages.append(f"Error! Input type `{type(v)}` is not `VariableShadowing`")
        else:
            match += 1
        # validate data type: AssertFail
        if not isinstance(v, AssertFail):
            error_messages.append(f"Error! Input type `{type(v)}` is not `AssertFail`")
        else:
            match += 1
        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when setting `actual_instance` in TransactionWarning with oneOf schemas: AssertFail, NonPositiveDeposit, NonPositivePayment, PartialPayment, VariableShadowing. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when setting `actual_instance` in TransactionWarning with oneOf schemas: AssertFail, NonPositiveDeposit, NonPositivePayment, PartialPayment, VariableShadowing. Details: " + ", ".join(error_messages))
        else:
            return v

    @classmethod
    def from_dict(cls, obj: dict) -> TransactionWarning:
        return cls.from_json(json.dumps(obj))

    @classmethod
    def from_json(cls, json_str: str) -> TransactionWarning:
        """Returns the object represented by the json string"""
        instance = TransactionWarning.construct()
        error_messages = []
        match = 0

        # deserialize data into NonPositiveDeposit
        try:
            instance.actual_instance = NonPositiveDeposit.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into NonPositivePayment
        try:
            instance.actual_instance = NonPositivePayment.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into PartialPayment
        try:
            instance.actual_instance = PartialPayment.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into VariableShadowing
        try:
            instance.actual_instance = VariableShadowing.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into AssertFail
        try:
            instance.actual_instance = AssertFail.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))

        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when deserializing the JSON string into TransactionWarning with oneOf schemas: AssertFail, NonPositiveDeposit, NonPositivePayment, PartialPayment, VariableShadowing. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when deserializing the JSON string into TransactionWarning with oneOf schemas: AssertFail, NonPositiveDeposit, NonPositivePayment, PartialPayment, VariableShadowing. Details: " + ", ".join(error_messages))
        else:
            return instance

    def to_json(self) -> str:
        """Returns the JSON representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        to_json = getattr(self.actual_instance, "to_json", None)
        if callable(to_json):
            return self.actual_instance.to_json()
        else:
            return json.dumps(self.actual_instance)

    def to_dict(self) -> dict:
        """Returns the dict representation of the actual instance"""
        if self.actual_instance is None:
            return None

        to_dict = getattr(self.actual_instance, "to_dict", None)
        if callable(to_dict):
            return self.actual_instance.to_dict()
        else:
            # primitive type
            return self.actual_instance

    def to_str(self) -> str:
        """Returns the string representation of the actual instance"""
        return pprint.pformat(self.dict())


